<?
# infoscreenCom.php
# Autor: Christian@Rotzoll.de
# Dieses Script stellt die Kommunikationsschnittstelle zu den Infoscreens dar.


# DIESES SCRIPT DARF NUR IN AUSNAHMEFLLEN DIE DAS OBJEKT INFOSCREENCONTROL_DATA SCHREIBEN
# GEFAHR EINES KONKURENTEN ZUGRIFFES!

require ("infoscreenComFunctions.php");
require ("infoscreenControlData.php");

  // Der Parameter screenname muss vorhanden sein, damit das Script wei welcher Infoscreen bedient wird
  if (issetPostGet("screenname") && (getPostGetText("screenname")!=""))
  {
    $screenname = getPostGetText("screenname");

    $group="";

    // Die InfoscreenControlDaten laden
    $icDataObjekt = loadInfoscreenControlDataObject("infoscreenCom.php");

    // Prfen, ob der Screen bereits bekannt ist
    if ($icDataObjekt->checkIfScreenIsRegistered($screenname))
    {
      // Der Screen ist bei einer Gruppe angemeldet
      $group = $icDataObjekt->getGroupNameOfScreen($screenname);
      $icDataObjekt->infoscreenGroups[$group]->infoscreens[$screenname]->storeContactData($_SERVER['REMOTE_ADDR']);
    }
    else
    {
      // Prfen, ob der Screen bereits als "noch nicht zugeordnet" gelistet ist
      if ($icDataObjekt->checkIfScreenIsNonRegistered($screenname))
      {
        // Der Screen wartet bereits auf seine Zuordnung
        $group = "";
        $icDataObjekt->nonRegisteredInfoScreens[$screenname]->storeContactData($_SERVER['REMOTE_ADDR']);
      }
      else
      {
        // Der Screen meldet sich zum ersten mal beim Controlscript
        $group 	= "";
        if (isset($_SERVER['REMOTE_ADDR']))
        {
          $ip 	= $_SERVER['REMOTE_ADDR'];
          if (!$icDataObjekt->addNonRegisteredScreen($screenname, $ip))
          {
            echo "FEHLER\nEs knnen keine weiteren Infoscreens in die Anmeldeschlange aufgenommen werden.";
            exit();
          }
          else
          {
            // Der Screen wurde aufgenommen. Test ob der Screen erreichbar ist
            $icDataObjekt->nonRegisteredInfoScreens[$screenname]->setFirewalled(connectTestToInfoscreen($_SERVER['REMOTE_ADDR']));
          }
        }
        else
        {
          echo "FEHLER\nIP des Infoscreens kann vom Controlscript nicht erfasst werden.";
          exit();
        }
      }
    }

    // Ebenso muss der Parameter aktion vorhanden sein, der die Absicht des Infoscreens beschreibt
    if (issetPostGet("action"))
    {
      $action = getPostGetText("action");

      ###################################################################
      # SCREEN FORDERT NEUE BEFEHLE AN
      ###################################################################
      if ($action == "getOrder")
      {
        if ($group=="")
        {
          infoscreenCommand("REGISTRATIONINFO","");
        }
        else
        {
          // NachrichtenKanle bermitteln
          infoscreenCommand("NEWSDATAUPDATE_START","");
          $proxy = $icDataObjekt->infoscreenGroups[$group]->infoscreens[$screenname]->getProxy();
          if ($proxy!="off")
          {
            infoscreenCommand("LADE_ALLE_DATEIEN_UEBER_KONTROLSCRIPT","");
            infoscreenCommand("TEST_PROXY","");
          }
          else
          {
            infoscreenCommand("LADE_ALLE_DATEIEN_DIREKT_AUS_DEM_NETZ","");
          }

          if ($icDataObjekt->showImpressum)
          {
            infoscreenCommand("SHOW_IMPRESSUM",$icDataObjekt->adminName.TRENNER.$icDataObjekt->adminEmail.TRENNER.$icDataObjekt->adminPost);
          }

          foreach ($icDataObjekt->infoscreenGroups[$group]->channels as $channel)
          {
            infoscreenCommand("KANAL_PARAMETER",$channel->name.TRENNER.$channel->importance.TRENNER.$channel->daylimit);
            infoscreenCommand("LADE_KANAL",$channel->url);
          }

          infoscreenCommand("NEWSDATAUPDATE_ENDE","");
          infoscreenCommand("WARTE","");
        }
      }
      ###################################################################
      # SCREEN FORDERT EINE DATEI AUS DEM NETZ AN
      ##################################################################
      else if ($action == "getFile")
      {

        if (issetPostGet("url"))
        {
          $url = getPostGetText("url");


          // Eine berprfung, ob die IP des Infoscreens den Proxy nutzen darf
          $proxy = $icDataObjekt->infoscreenGroups[$group]->infoscreens[$screenname]->getProxy();
          $ip 	= $_SERVER['REMOTE_ADDR'];

          if ($ip == $proxy)
          {
              // Nutzung erlaubt

              // Endung aus der URL extrahieren
              $endung = strrchr($url,".");

              // Prfen, ob die Datei geladen werden kann
              if (!@fopen($url,"r"))
              {
                header("Status: 404 Not Found",TRUE);

                // NOTFOUND-Bild ausgeben
                if (($endung==".gif") || ($endung==".jpg") || ($endung==".jpeg") )
                {
                  header("Content-type: image/gif",TRUE);
                  readfile("bild_notfound.gif");
                }
              }
              else
              {

                  if      ($endung==".jpg")  {header("Content-type: image/jpeg",TRUE);}
                  else if ($endung==".jpeg") {header("Content-type: image/jpeg",TRUE);}
                  else if ($endung==".gif")  {header("Content-type: image/gif",TRUE);}
                  else if ($endung==".png")  {header("Content-type: image/png",TRUE);}
                  else
                  {
                    // Es wir nun davon ausgegangen, dass eine TEXT-Datei vorliegt
                    // Falls es ein XML-Dokument ist wird versucht, dass encoding auszulesen

                    $erste_zeile = "";
                    $handle = fopen($url,"r");

                    while ((!feof($handle)) && ($erste_zeile==""))
                    {
                      $erste_zeile = fgets($handle);
                      $erste_zeile = trim($erste_zeile);
                    }

                    if (($erste_zeile!="")  && (substr_count($erste_zeile,"encoding")>0))
                    {
                      $first = @strpos($erste_zeile,"encoding=");
                      $last  = @strpos($erste_zeile," ",$first);
                      if ($last === FALSE)
                      { $last  = @strpos($erste_zeile,"?",$first); }
                      $encoding = @substr($erste_zeile,$first,$last-$first);

                      $first = @strpos($encoding,'"');
                      $last  = @strpos($encoding,'"',$first+1);
                      $charset = @substr($encoding,$first+1,$last-$first-1);

                      //echo "XX".$charset."XX";

                      if (($charset="iso-8859-1") || ($charset="UTF-16") || ($charset="UTF-8") || ($charset="EUC-JP") )
                      {
                        header ('Content-Type: application/xml; charset='.$charset.'',TRUE);
                      }
                      else
                      {
                        header ('Content-Type: application/xml; charset=UTF-8',TRUE);
                      }
                    }
                    else
                    {
                      header ('Content-Type: application/xml; charset=UTF-8',TRUE);
                    }
                  }

                  // Datei ausgeben
                  @readfile($url);
              }

          }
          else
          {
            // unerlaubte nutzung
            echo "Dieser Screen darf die Proxyfunktion nicht nutzen. Die IP ($ip) stimmt nicht mit den Einstellungen berein.";
          }

        }
        else
        {
          echo "FEHLER\nEs fehlt der Parameter `url` um die Datei zu identifizieren.";
        }
      }
      else
      {
        echo "FEHLER\nUnbekannte Aktion: $action";
      }
    }
    else
    {
      echo "FEHLER\nEs fehlt der Parameter `action`.";
    }
  }
  else
  {
    echo "FEHLER\nEs fehlt der Parameter `screenname`.";
  }

?>