<?

  ////////////////////////////////////////////////
  /// INIT
  ///////////////////////////////////////////////

  // passControl-Klasse einbinden
  require("passControl.php");

  // PEAR-PAKETE einbinden (siehe include-Verzeichnis)
  $includePath = "./include";
  if      (strrpos($_SERVER['PATH_TRANSLATED'],"/")>0)  {$includePath = substr($_SERVER['PATH_TRANSLATED'],0,strrpos($_SERVER['PATH_TRANSLATED'],"/")+1)."include";}
  else if (strrpos($_SERVER['PATH_TRANSLATED'],"\\")>0) {$includePath = substr($_SERVER['PATH_TRANSLATED'],0,strrpos($_SERVER['PATH_TRANSLATED'],"\\")+1)."include";}
  if (defined("PATH_SEPARATOR")) { ini_set("include_path", $includePath . PATH_SEPARATOR . ini_get("include_path")); }
  else 					         { ini_set('include_path', $includePath . ";" . ini_get('include_path')); }
  require_once "XML/RSS.php";

  // infoscreenControlData-Klasse einbinden
  require("infoscreenControlData.php");

  // Aufrufen, um den Passwortschutz fr dieses Script zu aktivieren
  $passControlObject = activate_passControl();
  $SESSIONID = $passControlObject->sessionid;

  ////////////////////////////////////////////////
  /// FUNKTIONEN
  ///////////////////////////////////////////////

  // infoscreenControlData-Klasse einbinden
  require("infoscreenControlFunctions.php");
  // Diese sind aus bersichtsgrnden in eine extraDatei ausgelagert

  ////////////////////////////////////////////////
  /// HAUPTPROGRAMM
  ///////////////////////////////////////////////

  // Test ob schon bereits Fehler ausgegeben wurden
  beforeAllEchos();

  // Den Kopfteil der HTMLSeite ausgeben
  display_HTML_Head();

  // Das InfoscreenControlData-Objekt mit allen relevanten Daten laden
  $icDataObject = loadInfoscreenControlDataObject("infoscreenControl.php");

  if (!issetPostGet("action"))
  {
    display_HTML_DataPlusOptions($icDataObject);
  }
  else
  {
    // Aktion auswerten
    $action = getPostGetText("action");
    // Versuchen Step zu ermitteln
    $step = 0; if (issetPostGet("step")) {  $step = getPostGetInt("step"); }

    // ---------------------------------------------------------
    // ------------ Aktion: Gruppe umbenennen
    if ($action=="renameGroup")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")))
        {
          $group  = getPostGetText("group");

          $more = '<input name="group" type="hidden" value="'.$group.'">';
          display_HTML_Dataform_Head("Gruppe umbenennen","renameGroup",1,$more);
          display_HTML_Dataform_InputRow("Neuer Name:",'<input name="newName" type="text" id="newName" value="'.$group.'" size="25" maxlength="35">');
          display_HTML_Dataform_Foot("Gruppennamen ndern");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("newName")))
        {
          $group   = getPostGetText("group");
          $newName = getPostGetText("newName");

          // Gruppe umbennen
          $icDataObject->renameGroup($group,$newName);
          htmlPrint("OK. Der Name wurde ge&auml;ndert.<br><br>");
          display_HTML_DataPlusOptions($icDataObject);
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Neue Gruppe anlegen
    else if ($action=="newGroup")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten

        display_HTML_Dataform_Head("Eine neue Gruppe anlegen","newGroup",1,"");
        display_HTML_Dataform_InputRow("Name der neuen Gruppe:",'<input name="groupName" type="text" id="groupName" value="" size="25" maxlength="35">');
        display_HTML_Dataform_Foot("Neue Gruppe anlegen");
        display_HTML_Help("Mehrere Gruppen ermglichen es, weitere Infoscreens mit einem unterschiedlichen NachrichtenMix zu bespielen.".
                        "Es versteht sich, dass ein bereits gewhlter Gruppenname nicht noch einmal vergeben werden kann.");
        htmlMainPageBacklink();

      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("groupName")))
        {
          $groupName  = getPostGetText("groupName");

          // Neue Gruppe anlegen
          if (!$icDataObject->checkIfGroupNameExists($groupName))
          {
            $icDataObject->addGroup($groupName);
            htmlPrint("OK. Die neue Gruppe wurde angelegt.<br><br>");
            display_HTML_DataPlusOptions($icDataObject);
          }
          else
          {
            htmlPrint("Problem: Der Gruppenname existiert bereits.");
            htmlMainPageBacklink();
          }

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Einen neuen Screen zur Gruppe hinzufgen
    else if ($action=="addNewScreenToGroup")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")))
        {
          $group  = getPostGetText("group");

          $more = '<input name="group" type="hidden" value="'.$group.'">';
          display_HTML_Dataform_Head("Einen neuen Infoscreen hinzufgen","addNewScreenToGroup",1,$more);
          display_HTML_Dataform_InputRow("Infoscreen ID:",'<input name="screenID" type="text" id="screenID" value="" size="25" maxlength="35">');
          display_HTML_Dataform_InputRow("Kurzbeschreibung:",'<input name="screenDescription" type="text" id="screenDescription" value="" size="25" maxlength="120">');
          display_HTML_Dataform_Foot("Infoscreen der Gruppe hinzufgen");
          display_HTML_Help("Wichtig ist hierbei die ID des Infoscreens. Sie muss eindeutig sein. Das heit Sie darf nur einmal im System verwendet werden. ".
                            "Da spter beim Infoscreen-Gert kein Leerzeichen im Namen (ID) verwendet werden kann, sollte das hier auch vermieden werden.");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screenID")) && (issetPostGet("screenDescription")))
        {
          $group   				= getPostGetText("group");
          $screenID 			= str_replace(" ","_",getPostGetText("screenID"));
          $screenDescription 	= getPostGetText("screenDescription");

          // Screen eintragen
          if ((!$icDataObject->checkIfScreenIsRegistered($screenID)) && (!$icDataObject->checkIfScreenIsNonRegistered($screenID)))
          {
            $icDataObject->newInfoscreen($group,$screenID,$screenDescription);

            if (issetPostGet("screen"))
            {
              $icDataObject->infoscreenGroups[$group]->removeInfoscreen(getPostGetText("screen"));
              htmlPrint("OK. Die Daten wurden ge&auml;ndert.<br><br>");
            }
            else
            {
              htmlPrint("OK. Der Infoscreen wurde hinzugef&uuml;gt.<br><br>");
            }
            display_HTML_DataPlusOptions($icDataObject);
          }
          else
          {
            if (issetPostGet("screen"))
            {
              $icDataObject->infoscreenGroups[$group]->removeInfoscreen($screenID);
              $icDataObject->newInfoscreen($group,$screenID,$screenDescription);
              htmlPrint("OK. Die Daten wurden ge&auml;ndert.<br><br>");
              display_HTML_DataPlusOptions($icDataObject);
            }
            else
            {
              htmlPrint("Problem: Die InfoscreenID ist bereits in Verwendung.");
            }
            htmlMainPageBacklink();
          }
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Einen neuen Screen zur Gruppe hinzufgen
    else if ($action=="editScreen")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screen")))
        {
          $group   = getPostGetText("group");
          $screen  = getPostGetText("screen");

          // Bisherige Daten des Infoscreens laden
          $name = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->ID;
          $desc = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->description;

          $more = '<input name="group" type="hidden" value="'.$group.'">'.
                  '<input name="screen" type="hidden" value="'.$screen.'">';
          display_HTML_Dataform_Head("Infoscreendaten bearbeiten","addNewScreenToGroup",1,$more);
          display_HTML_Dataform_InputRow("Infoscreen ID:",'<input name="screenID" type="text" id="screenID" value="'.$name.'" size="25" maxlength="35">');
          display_HTML_Dataform_InputRow("Kurzbeschreibung:",'<input name="screenDescription" type="text" id="screenDescription" value="'.$desc.'" size="25" maxlength="120">');
          display_HTML_Dataform_Foot("Infoscreendaten speichern");
          display_HTML_Help("Wichtig ist hierbei die ID des Infoscreens. Sie muss eindeutig sein. Das heit Sie darf nur einmal im System verwendet werden. ".
                            "Da spter beim Infoscreen-Gert kein Leerzeichen im Namen (ID) verwendet werden kann, sollte das hier auch vermieden werden.");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screenID")) && (issetPostGet("screenDescription")))
        {
          $group   				= getPostGetText("group");
          $screenID 			= str_replace(" ","_",getPostGetText("screenID"));
          $screenDescription 	= getPostGetText("screenDescription");

          // Screen eintragen
          if ((!$icDataObject->checkIfScreenIsRegistered($screenID)) && (!$icDataObject->checkIfScreenIsNonRegistered($screenID)))
          {
            $icDataObject->newInfoscreen($group,$screenID,$screenDescription);
            htmlPrint("OK. Der Infoscreen wurde hinzugef&uuml;gt.<br><br>");
            display_HTML_DataPlusOptions($icDataObject);
          }
          else
          {
            htmlPrint("Problem: Die InfoscreenID ist bereits in Verwendung.");
            htmlMainPageBacklink();
          }
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Die ProxyEinstellungen eines Screens verndern
    else if ($action=="editProxy")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screen")))
        {
          $group   = getPostGetText("group");
          $screen  = getPostGetText("screen");

          // Bisherige Daten des Infoscreens laden
          $name = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->ID;
          $proxy = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->getProxy();

          $more = '<input name="group" type="hidden" value="'.$group.'">'.
                  '<input name="screen" type="hidden" value="'.$screen.'">';
          display_HTML_Dataform_Head("Proxy-Einstellungen fr '".$name."'","editProxy",1,$more);
          display_HTML_Dataform_InputRow("Feste IP:",'<input name="ipmask" type="text" id="ipmask" value="'.$proxy.'" size="15" maxlength="15">');
          display_HTML_Dataform_Foot("Proxy-Einstellung setzten");
          display_HTML_Help("Wenn das Infoscreengert nicht auf das Internet zugreifen kann / darf, kann das Controlscript als ProxyServer fr die ".
                            " infoscreen-relevanten Daten gesetzt werden. Dazu muss aber das Infoscreengert ber eine feste IP-Adresse verfgen, die hier eingetragen werden muss. ".
                            "Dies geschiet zur Sicherheit, damit die Proxyfunktion nicht von auen missbraucht werden kann.<br> Setzen Sie das IP-Feld auf 'off', um die Proxy-Einstellung zu deaktivieren.");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screen")) && (issetPostGet("ipmask")))
        {
          $group   				= getPostGetText("group");
          $screenID 			= str_replace(" ","_",getPostGetText("screen"));
          $ipmask           	= getPostGetText("ipmask");

          $icDataObject->infoscreenGroups[$group]->infoscreens[$screenID]->setProxy($ipmask);
          htmlPrint("OK. Die Einstellung wurde gesetzt.<br><br>");
          display_HTML_DataPlusOptions($icDataObject);

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Einen neuen Kanal zur Gruppe hinzufgen
    else if ($action=="addNewChannelToGroup")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")))
        {
          $group  = getPostGetText("group");

          $more = '<input name="group" type="hidden" value="'.$group.'">';

          display_HTML_Dataform_Head("Einen neuen Kanal hinzufgen","addNewChannelToGroup",1,$more);
          display_HTML_Dataform_InputRow("Name des Infokanals:",'<input name="channelName" type="text" id="channelName" value="" size="25" maxlength="35">');
          display_HTML_Dataform_InputRow("Die WWW-Adresse:",'<input name="channelURL" type="text" id="channelURL" value="http://" size="25" maxlength="150">');
          $mixselect = '<select name="mixAnteil" size="1">'.
          '<option value="1">sehr gering</option>'.
          '<option value="2">gering</option>'.
          '<option value="3" selected>normal</option>'.
          '<option value="4">hoch</option>'.
          '<option value="5">sehr hoch</option>'.
          '</select>';
          display_HTML_Dataform_InputRow("Anteil am Mix:",$mixselect);
          display_HTML_Dataform_InputRow("Akualit&auml;t:",'<input name="daylimit" type="text" id="daylimit" value="7" size="5" maxlength="5"> Tage');
          display_HTML_Dataform_Foot("Infokanal der Gruppe hinzufgen");
          display_HTML_Help("Ein Infokanal ist z.B. ein RSS-Feed von einer Nachrichtenseite oder einem Weblog. Der Name des Kanals wird auf dem Infoscreen angezeigt. ".
                            "'Anteil am Mix' bedeutet, wie oft die Nachrichten dieses Kanales auf den Infoscreens dieser Gruppe anzeigt werden sollen.");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("channelName")) && (issetPostGet("channelURL")) && (issetPostGet("mixAnteil")) && (issetPostGet("daylimit")))
        {
          $group   				= getPostGetText("group");
          $channelName 			= getPostGetText("channelName");
          $channelURL 			= getPostGetText("channelURL");
          $mixAnteil			= getPostGetInt("mixAnteil");
          $daylimit				= getPostGetInt("daylimit");

          // Kanal hinzufgen
          $icDataObject->newChannel($group,$channelName,$channelURL);
          $icDataObject->infoscreenGroups[$group]->channels[$channelName]->importance = $mixAnteil;
          $icDataObject->infoscreenGroups[$group]->channels[$channelName]->daylimit = $daylimit;

          // Falls die Daten von "editChannel" kommen ist der Parameter Channel gesetzt
          if (issetPostGet("channel"))
          {
            // Falls der Name gendert wurde: Wurde ein jetzt ein Kanal mit dem neuen Namen angelegt
            // folglich muss jetzt der alte Kanal gelscht werden
            if (getPostGetText("channel")!=$channelName)
            {
              $icDataObject->infoscreenGroups[$group]->removeChannel(getPostGetText("channel"));
            }
            htmlPrint("OK. Die nderungen wurden gespeichert.<br><br>");
            
            // Alle Screens der Gruppe aufforden sich den neuen ChannelMix zu laden
            foreach ($icDataObject->infoscreenGroups[$group]->infoscreens as $screenObject)
            {
             $screen = $screenObject->ID;
             if (!$icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->isFirewalled())
             {
               $ip = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
               sendDirectCommandToScreen($ip,"update Channelmix");
             }       
            } 
                     
            display_HTML_DataPlusOptions($icDataObject);
          }
          else
          {
            // Die Daten kommen von addNewChannelToGroup
            htmlPrint("OK. Der InfoKanal wurde hinzugef&uuml;gt.<br><br>");
            display_HTML_DataPlusOptions($icDataObject);
          }

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Kanal editieren
    else if ($action=="editChannel")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("channel")))
        {
          $group    = getPostGetText("group");
          $channel  = getPostGetText("channel");

          // Daten aus bisherigem Kanal holen
          $url				= $icDataObject->infoscreenGroups[$group]->channels[$channel]->url;
          $importance		= $icDataObject->infoscreenGroups[$group]->channels[$channel]->importance;
          $daylimit			= $icDataObject->infoscreenGroups[$group]->channels[$channel]->daylimit;

          $mixselect = '<select name="mixAnteil" size="1">';
          if ($importance == 1) $mixselect = $mixselect.'<option value="1" selected>sehr gering</option>';
          else 					$mixselect = $mixselect.'<option value="1">sehr gering</option>';
          if ($importance == 2) $mixselect = $mixselect.'<option value="2" selected>gering</option>';
          else 					$mixselect = $mixselect.'<option value="2">gering</option>';
          if ($importance == 3) $mixselect = $mixselect.'<option value="3" selected>normal</option>';
          else 					$mixselect = $mixselect.'<option value="3">normal</option>';
          if ($importance == 4) $mixselect = $mixselect.'<option value="4" selected>hoch</option>';
          else 					$mixselect = $mixselect.'<option value="4">hoch</option>';
          if ($importance == 5) $mixselect = $mixselect.'<option value="5" selected>sehr hoch</option>';
          else 					$mixselect = $mixselect.'<option value="5">sehr hoch</option>';
          $mixselect = $mixselect.'</select>';

          $more = '<input name="group" type="hidden" value="'.$group.'">'.
                  '<input name="channel" type="hidden" value="'.$channel.'">';
          display_HTML_Dataform_Head("Kanal bearbeiten","addNewChannelToGroup",1,$more);
          display_HTML_Dataform_InputRow("Name des Infokanals:",'<input name="channelName" type="text" id="channelName" value="'.$channel.'" size="25" maxlength="35">');
          display_HTML_Dataform_InputRow("Die WWW-Adresse:",'<input name="channelURL" type="text" id="channelURL" value="'.$url.'" size="25" maxlength="150">');
          display_HTML_Dataform_InputRow("Anteil am Mix:",$mixselect);
          display_HTML_Dataform_InputRow("Akualit&auml;t:",'<input name="daylimit" type="text" id="daylimit" value="'.$daylimit.'" size="5" maxlength="5"> Tage');
          display_HTML_Dataform_Foot("Infokanal der Gruppe hinzufgen");
          display_HTML_Help("Ein Infokanal ist z.B. ein RSS-Feed von einer Nachrichtenseite oder einem Weblog. Der Name des Kanals wird auf dem Infoscreen angezeigt. ".
                            "'Anteil am Mix' bedeutet, wie oft die Nachrichten dieses Kanales auf den Infoscreens dieser Gruppe anzeigt werden sollen.");
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      // editChannel zur zur Auswertung der genderten Daten den Step1 von addNewChannelToGroup
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Infoscreen aus Gruppe lschen
    else if ($action=="deleteScreen")
    {
      // Parameter auswerten
      if ((issetPostGet("group")) && (issetPostGet("screen")))
      {
        $group  = getPostGetText("group");
        $screen = getPostGetText("screen");

        $icDataObject->infoscreenGroups[$group]->removeInfoscreen($screen);
        if (file_exists("./Data/infoscreen_".$screen."_DATA.php"))
        {
          unlink("./Data/infoscreen_".$screen."_DATA.php");
        }
        htmlPrint("OK. Der Infoscreen wurde aus der Gruppe entfernt.<br><br>");
        display_HTML_DataPlusOptions($icDataObject);
      }
      else
      {
        htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
        htmlMainPageBacklink();
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Kanal aus Gruppe lschen
    else if ($action=="deleteChannel")
    {
      // Parameter auswerten
      if ((issetPostGet("group")) && (issetPostGet("channel")))
      {
        $group  = getPostGetText("group");
        $channel = getPostGetText("channel");

        $icDataObject->infoscreenGroups[$group]->removeChannel($channel);
        htmlPrint("OK. Der InfoKanal wurde aus der Gruppe entfernt.<br><br>");
        
        // Alle Screens der Gruppe aufforden sich den neuen ChannelMix zu laden
        foreach ($icDataObject->infoscreenGroups[$group]->infoscreens as $screenObject)
        {
         $screen = $screenObject->ID;
         if (!$icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->isFirewalled())
         {
           $ip = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
           sendDirectCommandToScreen($ip,"update Channelmix");
         }       
        } 
         
        display_HTML_DataPlusOptions($icDataObject);
      }
      else
      {
        htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
        htmlMainPageBacklink();
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Gruppe lschen
    else if ($action=="deleteGroup")
    {
      if ($step==0)
      {
          $group  = getPostGetText("group");

          $more = '<input name="group" type="hidden" value="'.$group.'">';
          display_HTML_Dataform_Head("Sicherheitsfrage","deleteGroup",1,$more);
          echo "<tr><td>";
          htmlPrint("Soll die Gruppe '".$group."' wirklich gelscht werden?");
          echo "</tr></td>";
          display_HTML_Dataform_Foot("Gruppe endgltig lschen");
          htmlMainPageBacklink();
      }
      else if ($step==1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")))
        {
          $group  = getPostGetText("group");

            // Alle Screens der Gruppe aufforden sich den neuen ChannelMix zu laden
            foreach ($icDataObject->infoscreenGroups[$group]->infoscreens as $screenObject)
            {
             $screen = $screenObject->ID;
             if (!$icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->isFirewalled())
             {
               $ip = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
               sendDirectCommandToScreen($ip,"update Channelmix");
             }       
            } 

          $icDataObject->removeGroup($group);
          htmlPrint("OK. Die Gruppe wurde entfernt.<br><br>");        
          
          display_HTML_DataPlusOptions($icDataObject);
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Infoscreen aus Gruppe lschen
    else if ($action=="deleteScreenFromNonRegistered")
    {
      // Parameter auswerten
      if ((issetPostGet("screen")))
      {
        $screen = getPostGetText("screen");
        unset($icDataObject->nonRegisteredInfoScreens[$screen]);
        if (file_exists("./Data/infoscreen_".$screen."_DATA.php"))
        {
          unlink("./Data/infoscreen_".$screen."_DATA.php");
        }
        htmlPrint("OK. Der Infoscreen wurde entfernt.<br><br>");
        display_HTML_DataPlusOptions($icDataObject);
      }
      else
      {
        htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
        htmlMainPageBacklink();
      }
    }



    // ---------------------------------------------------------
    // ------------ Aktion: Einen noch nicht zugeordneten Screen einer Gruppe zuordnen
    else if ($action=="assignScreenToGroup")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("screen")))
        {
          $screen  = getPostGetText("screen");

          if (count($icDataObject->infoscreenGroups) == 0)
          {
            htmlPrint("Es ist noch keine Gruppe vorhanden. Bitte zuerst eine Gruppe anlegen.");
          }
          else
          {
            $more = '<input name="screen" type="hidden" value="'.$screen.'">';

            display_HTML_Dataform_Head("Bitte eine Gruppe fr diesen Infoscreen whlen","assignScreenToGroup",1,$more);
            $mixselect = returnGroupSelectFormElement($icDataObject);
            display_HTML_Dataform_InputRow("Bestehende Gruppe:",$mixselect);
            display_HTML_Dataform_Foot("Infoscreen dieser Gruppe hinzufgen");
          }
          htmlMainPageBacklink();
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("group")) && (issetPostGet("screen")))
        {
          $group   				= getPostGetText("group");
          $screen 				= getPostGetText("screen");

          // in Gruppe einfgen
          $icDataObject->infoscreenGroups[$group]->infoscreens[$screen] = $icDataObject->nonRegisteredInfoScreens[$screen];
          // aus nonRegistered entfernen
          unset($icDataObject->nonRegisteredInfoScreens[$screen]);

         htmlPrint("OK. Der Screen wurde der Gruppe zugeteilt.<br><br>");
         
         // Den Screen aufforden sich den neuen ChannelMix zu laden
         if (!$icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->isFirewalled())
         {
           $ip = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
           sendDirectCommandToScreen($ip,"update Channelmix");
         }
         
         display_HTML_DataPlusOptions($icDataObject);

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Impressums einstellungen
    else if ($action=="impressum")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Bisherige Daten vorbereiten

        $adminName  = $icDataObject->adminName;
        $adminMail  = $icDataObject->adminEmail;
        $adminPost  = $icDataObject->adminPost;
        if ($icDataObject->showImpressum) {$impressum  = " checked";}
        else							  {$impressum  = "";}

        display_HTML_Dataform_Head("Impressumseinstellungen","impressum",1,"");
        display_HTML_Dataform_InputRow("Impressum aktiv:",'<input name="impressum" type="checkbox" id="impressum" value="on"'.$impressum.'>');
        display_HTML_Dataform_InputRow("ADMIN Name:",'<input name="adminName" type="text" id="adminName" value="'.$adminName.'" size="25" maxlength="50">');
        display_HTML_Dataform_InputRow("ADMIN eMail:",'<input name="adminMail" type="text" id="adminMail" value="'.$adminMail.'" size="25" maxlength="50">');
        display_HTML_Dataform_InputRow("ADMIN Postanschrift:",'<input name="adminPost" type="text" id="adminPost" value="'.$adminPost.'" size="25" maxlength="120">');
        display_HTML_Dataform_Foot("Impressumseinstellungen setzten");
        display_HTML_Help("Wenn das Impressum aktiviert ist, so wird gelegentlich (sehr niedriger MixAnteil) auf dem Infoscreen eine Impressumstafel eingeblendet. ".
                          "Der ADMIN wird bei aktiviertem Impressum zum ViSdP (Verantwortlicher im Sinne des Pressrechtes). Allerdings wird im Impressum darauf hingewiesen, ".
                          "dass der ADMIN nicht fr den Inhalt namentlich gekennzeichneter Nachrichten verantwortlich ist.");
        htmlMainPageBacklink();

      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("adminName")) && (issetPostGet("adminMail")) && (issetPostGet("adminPost")))
        {
          $adminName  = getPostGetText("adminName");
          $adminMail  = getPostGetText("adminMail");
          $adminPost  = getPostGetText("adminPost");

          if ((issetPostGet("impressum"))) {$impressum = getPostGetText("impressum");}
          else 							   {$impressum = "off";}

          // Impressums Daten aktualisieren
          if ($impressum == "on") {$icDataObject->showImpressum=TRUE;}
          else					  {$icDataObject->showImpressum=FALSE;}

          $icDataObject->adminName	= $adminName;
          $icDataObject->adminEmail	= $adminMail;
          $icDataObject->adminPost  = $adminPost;

          htmlPrint("OK. Neue Impressumseinstellungen wurde gesetzt.<br><br>");
          display_HTML_DataPlusOptions($icDataObject);
        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Passwort ndern
    else if ($action=="changePasswort")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten

        display_HTML_Dataform_Head("Das Login-Passwort ndern","changePasswort",1,"");
        display_HTML_Dataform_InputRow("Altes Passwort:",'<input name="oldPassword" type="text" id="oldPassword" value="" size="15" maxlength="15">');
        display_HTML_Dataform_InputRow("Neues Passwort:",'<input name="newPassword" type="text" id="newPassword" value="" size="15" maxlength="15">');
        display_HTML_Dataform_Foot("Neues Passwort setzten");
        display_HTML_Help("Bitte immer daran denken, dass das Infoscreen-Control-Center nur von einer Person aufeinmal bedient werden kann. ".
                        "Ansonsten kann es zu unvorhergesehenden Aktionen oder Datenverlust kommen.");
        htmlMainPageBacklink();

      }
      else if ($step == 1)
      {
        // Parameter auswerten
        if ((issetPostGet("oldPassword")) && (issetPostGet("newPassword")))
        {
          $oldPassword  = getPostGetText("oldPassword");
          $newPassword  = getPostGetText("newPassword");

          // Passwort ndern
          if ($passControlObject->checkPassword($oldPassword))
          {
            $passControlObject->setNewPassword($newPassword);
            htmlPrint("OK. Die neues Passwort wurde gesetzt.<br><br>");
            display_HTML_DataPlusOptions($icDataObject);
          }
          else
          {
            htmlPrint("Problem: Das alte Passwort war nicht korrekt.<br>Es wurde KEIN neues Passwort gesetzt.");
            htmlMainPageBacklink();
          }

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
      }
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Logout
    else if ($action=="refresh")
    {
      display_HTML_DataPlusOptions($icDataObject);
    }

    // ---------------------------------------------------------
    // ------------ Aktion: Logout
    else if ($action=="logout")
    {
      $passControlObject->logout();
      htmlPrint("Sie haben das System erfolgreich verlassen.");
    }

    // --------------------------------------------------------- Newsflash
    // ------------ Aktion: Infoscreen Aktion
    else if ($action=="doActionOnScreen")
    {
      if      ($step == 0)
      // -- Erster Schritt: Formular ausgeben
      {
        // Parameter auswerten
        if ((issetPostGet("screen")) && (issetPostGet("group")))
        {
        
            $group  = getPostGetText("group");
            $screen = getPostGetText("screen");       
        
            // Die letzte IP des Rechners extrahieren 
            $ip  = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
            
            if ($ip!="")
            {
              $firewalled = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->isFirewalled(); 
              if (!$firewalled)
              {
                if (connectTestToInfoscreen($ip))
                {
                  htmlPrint("Der Screen ist momentan ONLINE.");
                  
                  echo "<br>";
                  htmlPrint("[&nbsp;<a href='infoscreenControl.php?screen=$screen&group=$group&action=$action&step=3&sessionID=".$GLOBALS['SESSIONID']."'>Newsflash auf dem Infoscreen ausgeben.</a>&nbsp;]");                    
                  echo "<br>";
                  htmlPrint("[&nbsp;<a href='infoscreenControl.php?screen=$screen&group=$group&action=$action&step=5&sessionID=".$GLOBALS['SESSIONID']."'>KanalMix neu anfordern</a>&nbsp;]");                   
                  
                  htmlMainPageBacklink();    
                }
                else
                {
                  htmlPrint("Der Screen ist momentan offline. Es knnen auf ihm keine Aktionen ausgefhrt werden.");
                  htmlMainPageBacklink();                  
                }
              }
              else
              {
                htmlPrint("Der Screen liegt hinter einer Firewall oder NAT. Es knnen auf ihm keine Aktionen ausgefhrt werden.");

                echo "<br>";
                htmlPrint("[&nbsp;<a href='infoscreenControl.php?screen=$screen&group=$group&action=$action&step=10&sessionID=".$GLOBALS['SESSIONID']."'>Erneut die Erreichbarkeit testen.</a>&nbsp;]");                

                htmlMainPageBacklink();                   
              }
            }
            else
            {
              htmlPrint("Der Screen hat sich noch nie mit dem ControlScript verbunden. Es liegen keine Kontaktdaten vor.");
              htmlMainPageBacklink();                  
            }         
      
        }

      }
      else if ($step == 3)
      {
        // Parameter auswerten
        if ((issetPostGet("screen")) && (issetPostGet("group")))
        {
        
            $group  = getPostGetText("group");
            $screen = getPostGetText("screen");    

            $more = '<input name="group" type="hidden" value="'.$group.'">'.
                    '<input name="screen" type="hidden" value="'.$screen.'">';
            display_HTML_Dataform_Head("Newsflash ausgeben","doActionOnScreen",4,$more);
            display_HTML_Dataform_InputRow("Minuten:",'<input name="duration" type="text" id="duration" value="" size="4" maxlength="4">');
            display_HTML_Dataform_InputRow("Text:",'<textarea name="text" cols="15" rows="8"></textarea>');
            display_HTML_Dataform_Foot("Newsflash ausgeben");
            htmlMainPageBacklink();
            

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
        
      }   
      else if ($step == 4)
      {
        // Parameter auswerten
        if ((issetPostGet("screen")) && (issetPostGet("group")) && (issetPostGet("text")) && (issetPostGet("duration")))
        {
        
            $group  = getPostGetText("group");
            $screen = getPostGetText("screen");
            $text	= getPostGetText("text");  
            $dauer  = getPostGetText("duration");  

            // Die letzte IP des Rechners extrahieren 
            $ip  = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
            
            // Kommando senden            
            sendDirectCommandToScreen($ip,"Newsflash\r\n$dauer\r\n$text");

            htmlPrint("Newsflash wird ausgegeben.");
            htmlMainPageBacklink();
            

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
        
      }        
      else if ($step == 5)
      {
        // Parameter auswerten
        if ((issetPostGet("screen")) && (issetPostGet("group")))
        {
        
            $group  = getPostGetText("group");
            $screen = getPostGetText("screen"); 

            // Die letzte IP des Rechners extrahieren 
            $ip  = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
            
            // Kommando senden            
            sendDirectCommandToScreen($ip,"update Channelmix");

            htmlPrint("Updatekomando gesendet.");
            htmlMainPageBacklink();
            

        }
        else
        {
          htmlPrint("Programmierfehler: Fr diese Aktion fehlen notwendige Parameter.");
          htmlMainPageBacklink();
        }
        
      }         
      else if ($step == 10)
      {
        // Parameter auswerten
        if ((issetPostGet("screen")) && (issetPostGet("group")))
        {      
            $group  = getPostGetText("group");
            $screen = getPostGetText("screen");       
        
            // Die letzte IP des Rechners extrahieren 
            $ip  = $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->lastIP;
            
            if (connectTestToInfoscreen($ip))
            {
              $icDataObject->infoscreenGroups[$group]->infoscreens[$screen]->setFirewalled(FALSE);   
              htmlPrint("Der aktuelle Test hat ergeben, dass der Screen doch erreichbar ist.");

              echo "<br><br>";
              htmlPrint("[&nbsp;<a href='infoscreenControl.php?screen=$screen&group=$group&action=$action&step=0sessionID=".$GLOBALS['SESSIONID']."'>Nun Aktion ausfhren</a>&nbsp;]");                

              htmlMainPageBacklink();                            
            }
            else
            {
              htmlPrint("Der aktuelle Test hat weiterhin besttigt, dass der Screen nicht erreichbar ist.<br>Dies kann aber auch daran liegen, dass er zur Zeit offline ist.");

              htmlMainPageBacklink();               
            }
        }          
      }        
    }

    // ---------------------------------------------------------
    // ------------ Aktion: unbekannt
    else
    {
      htmlPrint("Aktion='".$action."'<br>Unbekannte oder noch nicht realisierte Funktion.");
      htmlMainPageBacklink();
    }
  }

  // nderungen im InfoscreenControlData-Objekt speichern
  $icDataObject->saveThisObject();

  // Den Endteil der HTMLSeite ausgeben
  display_HTML_Foot();

  // Datenbericht des InfoscreenControlData-Objekt ausgeben
  //echo $icDataObject->toString();
?>