<?

 ////////////////////////////////////////////////////////////
 // infoscreenControlData KLASSEN

 // Diese Klasse speichert alle Daten fr infoscreenControll.php
 class infoscreenControlData {

	  // Bemerkung: Werden den Variablen der Klasse nderungen vollzogen;
	  // immer die Datei "infoscreenControl_DATA.php" lschen

	  var $infoscreenGroups; // Array mit infoscreenGroup-Objekten

	  var $nonRegisteredInfoScreens; // Array mit Infoscreens (InfoscreenData-Ojekten), die noch keiner Gruppe zugeornet wurden
      var $MAX_nonRegisteredInfosreens = 100; // Um einem Angriff auf das System vorzubeugen wird die maximale Anzahl der unregistrierten Infoscreens beschrnkt

	  var $adminName;		 // Name des Admins
	  var $adminEmail;		 // Email des Admins
	  var $adminPost;		 // Postanschrift des Admins

	  var $schowImpressum;	// Boolean, ob eine Impressumtafel angezeigt werden soll
	  var $moreParameter;  // Array fr weitere Parameter


      // Konstruktor
      function infoscreenControlData()
      {
        // GruppenArray mit einer Defaultgruppe initialisieren
        $this->infoscreenGroups = array();
        $this->addGroup("defaultGruppe");

        // Unregistriert-Array initialisiereb
        $this->nonRegisteredInfoScreens = array();

        $this->adminName		= "unbekannt";
        $this->adminEmail		= "unbekannt";
        $this->adminPost		= "unbekannt";
        $this->showImpressum	= FALSE;
    	$this->moreParameter 	= array();
      }

      // fgt eine Gruppe ein
      function addGroup($nam)
      {
        $groupObject = new infoscreenGroup($nam);
        $this->infoscreenGroups[$nam]= $groupObject;
      }

      // entfernt eine Gruppe
      function removeGroup($nam)
      {
        unset($this->infoscreenGroups[$nam]);
      }

      // umbennen einer Gruppe
      function renameGroup ($altname, $neuname)
      {
        if ($this->checkIfGroupNameExists($altname))
        {
          if (!$this->checkIfGroupNameExists($neuname))
          {
            $group = $this->infoscreenGroups[$altname];
            $group->name = $neuname;

            unset($this->infoscreenGroups[$altname]);
            $this->infoscreenGroups[$neuname]= $group;
          }
          else
          {
            echo "renameGroup: Es existiert bereits eine Gruppe mit diesem Namen.<br>";
          }
        }
        else
        {
           echo "renameGroup: Die Gruppe existiert nicht.<br>";
        }
      }

      function addNonRegisteredScreen($screenname, $ip)
      {
        if ( count($this->nonRegisteredInfoScreens) <= $this->MAX_nonRegisteredInfosreens )
        {
          $screen =  new InfoscreenData($screenname);
          $screen->storeContactData($ip);
          $this->nonRegisteredInfoScreens[$screenname] = $screen;
          $this->saveThisObject();
          return TRUE;
        }
        else
        {
          return FALSE;
        }
      }

      // Prft, ob ein Gruppenname bereits existiert
      function checkIfGroupNameExists($nam)
      {
        foreach ($this->infoscreenGroups as $group)
        {
          if ($group->name == $nam) return TRUE;
        }
        return FALSE;
      }

      // Prft, ob der Screen bereits einer Gruppe zugeordnet ist
      function checkIfScreenIsRegistered($nam)
      {
        foreach ($this->infoscreenGroups as $group)
        {
          foreach ($group->infoscreens as $screen)
          {
            if ($screen->ID == $nam) return TRUE;
          }
        }
        return FALSE;
      }

      // gibt die Gruppe zurck in der sich der genannte Screen befindet
      function getGroupNameOfScreen($nam)
      {
        foreach ($this->infoscreenGroups as $group)
        {
          foreach ($group->infoscreens as $screen)
          {
            if ($screen->ID == $nam) return $group->name;
          }
        }
        return "";
      }

      // Prft, ob ein Gruppenname bereits existiert
      function checkIfScreenIsNonRegistered($nam)
      {
        foreach ($this->nonRegisteredInfoScreens as $screen)
        {
          if ($screen->ID == $nam) return TRUE;
        }
        return FALSE;
      }

      function newInfoscreen($group, $nam, $desc)
      {
       if ((!$this->checkIfScreenIsRegistered($nam)) && (!$this->checkIfScreenIsNonRegistered($nam)))
       {
        $this->infoscreenGroups[$group]->addInfoscreen($nam);
        $this->infoscreenGroups[$group]->infoscreens[$nam]->description = $desc;
       }
      }

      function newChannel($group, $nam, $url)
      {
        $this->infoscreenGroups[$group]->addChannel($nam, $url);
      }

      // Diese Methode speichert das Objekt
      function saveThisObject()
      {
        // Dieses Objekt (mit seinen Daten) in einen String umwandeln
        $objectAsString = serialize($this);

        // Den ObjektString speichern
        $dat = fopen("./Data/infoscreenControl_DATA.php","w");
          fwrite($dat,"<? // infoscreenControl_DATA.php - NICHT EDITIEREN!! \n".$objectAsString."\n?>Finger wech du Schelm!");
        fclose($dat);

        if (!file_exists("./Data/infoscreenControl_DATA.php"))
        {
          echo "infoscreenControlData.php : Es koennen keine Daten gespeichert werden. Bitte Schreibrechte aktivieren.";
          exit();
        }
      }

      // Gibt einen vollstndigen Datenbericht des Objektes als String aus
      function toString()
      {
        $output = "# INFOSCREENCONTROLDATA-Objekt:<br>Admindata: ".$this->adminName." / ".$this->adminEmail." / ".$this->adminPost;
        if ($this->showImpressum) 	{$output = $output."<br>Impressum: AN";}
        else 						{$output = $output."<br>Impressum: AUS";}
        $output = $output."<br>Anzahl der Gruppen: ".count($this->infoscreenGroups);
        foreach($this->infoscreenGroups as $group)
        {
          $output = $output.$group->toString();
        }
        $output = $output."<br><br>Anzahl der noch nicht zugeordneten Infoscreens: ".count($this->nonRegisteredInfoScreens);
        foreach($this->nonRegisteredInfoScreens as $screen)
        {
          $output = $output.$screen->toString();
        }
        return $output;
      }
 }

 class infoscreenGroup
 {
    var $name;				// Name der Gruppe
    var $infoscreens;		// Array von infoscreens (infoscreenData-Objekte), die zu der Gruppe gehren
    var $channels;			// Array von Channel-Objekten, die auf die Gruppe geschaltet sind
 	var $moreParameter;     // Array fr weitere Parameter

    function infoscreenGroup($groupname)
    {
      $this->name 			= $groupname;
      $this->infoscreens	= array();
      $this->channels		= array();
 	  $this->moreParameter  = array();
    }

    // fgt der Gruppe einen Kanal hinzu
    function addChannel($chan, $url)
    {
      $chanObject = new channel($chan, $url);
      $this->channels[$chan]= $chanObject;
    }

    // entfernt einen Kanal
    function removeChannel($chan)
    {
      unset($this->channels[$chan]);
    }

    // fgt der Gruppe einen Infoscreen hinzu
    function addInfoscreen($screen)
    {
      $screenObject = new infoscreenData($screen);
      $this->infoscreens[$screen]= $screenObject;
    }

    // entfernt einen Infoscreen
    function removeInfoscreen($screen)
    {
      unset($this->infoscreens[$screen]);
    }

    function toString()
    {
      $output="<br><br># INFOSCREENGROUP: ".$this->name;
      $output=$output."<br>Anzahl der zugeordneten Infoscreens: ".count($this->infoscreens);
      foreach ($this->infoscreens as $screen)
      {
        $output = $output.$screen->toString();
      }
      $output=$output."<br>Anzahl der zugeordneten Kanle: ".count($this->channels);
      foreach ($this->channels as $channel)
      {
        $output = $output.$channel->toString();
      }
      $output=$output."<br># --------------";
      return $output;
    }
 }

 class infoscreenData {

 	var $ID; 			// ID des Infoscreens (eindeutiger Name im ganzen System)
 	var $description;	// Beschreibungstext des Screens
 	var $lastIP;		// die IP unter der der Screens zuletzt erreichbar war
 	var $lastContact;	// Timestamp des letzten Kontaktes zum Screen
 	var $moreParameter; // Array fr weitere Parameter

 	function infoscreenData($id)
 	{
 	  $this->ID 			= $id;
 	  $this->description 	= "Dieser Screen beitzt noch keine Beschreibung.";
 	  $this->lastIP			= "";
 	  $this->lastContact	= 0;
 	  $this->moreParameter = array();
 	}

 	function storeContactData($ip)
 	{
 	  $this->lastIP			= $ip;
 	  $this->lastContact	= time();
 	  // Die KontaktDaten in eigener InfoscreenDatei speichern
 	  $this->saveThisObject();
 	}

    function toString()
    {
      $output="<br><br># INFOSCREENDATA: ".$this->ID;
      $output=$output."<br># --------------";
      return $output;
    }

    function getProxy()
    {
      if (!isset($this->moreParameter["proxy"]))
      {
        // init Value
        $this->moreParameter["proxy"] = "off";
      }
      return $this->moreParameter["proxy"];
    }

    function setProxy($ipmask)
    {
      $this->moreParameter["proxy"] = $ipmask;
    }
    
    function isFirewalled()
    {
      if (!isset($this->moreParameter["firewalled"]))
      {
        // init Value
        $this->moreParameter["firewalled"] = "yes";
      }
      
      if ($this->moreParameter["firewalled"]=="yes")
      {
        return TRUE;
      }
      else
      {
        return FALSE;      
      }
    }

    function setFirewalled($bool)
    {
      if ($bool)
      {
        $this->moreParameter["firewalled"] = "yes";
      }
      else
      {
        $this->moreParameter["firewalled"] = "no";      
      }
      $this->saveThisObject();
    }    

    // Diese Methode speichert das Objekt
    function saveThisObject()
    {
      // Dieses Objekt (mit seinen Daten) in einen String umwandeln
      $objectAsString = serialize($this);

      // Den ObjektString speichern
      $dat = fopen("./Data/infoscreen_".$this->ID."_DATA.php","w");
      fwrite($dat,"<? // Daten des Infoscreens '".$this->ID."' - NICHT EDITIEREN!! \n".$objectAsString."\n?>Finger wech du Schelm!");
      fclose($dat);

      if (!file_exists("./Data/infoscreen_".$this->ID."_DATA.php"))
      {
        echo "infoscreenControlData.php : Es koennen keine Daten gespeichert werden. Bitte Schreibrechte aktivieren.";
        exit();
      }
    }
 }

 class channel {

  	var $name;			// Name des Kanals
  	var $url;			// WWW-Adresse des Kanals
  	var $importance;	// Wichtigkeit des Kanals (1 bis 10)
  	var $updateMinutes;	// Updatezyklus des Kanals in Minuten
  	var $moreParameter; // Array fr weitere Parameter

    // Konstruktor
    function channel($nam, $uri)
    {
      $this->name 		= $nam;
      $this->url  		= $uri;
      $this->daylimit	= 7;
      $this->importance = 3;
      $this->moreParameter = array();
    }

    // FUNKTIONEN, um Informationen aus dem Kanal zu laden
    // getNewsAsNITFsegments
    // getNewsAsHMTLoverview
    // checkStatusOfChannel

    function importanceAsString()
    {
      if      ($this->importance==1)
      { return "sehr niedrig"; }
      else if ($this->importance==2)
      { return "niedrig"; }
      else if ($this->importance==3)
      { return "normal"; }
      else if ($this->importance==4)
      { return "hoch"; }
      else if ($this->importance==5)
      { return "sehr hoch"; }
      else
      { return "nicht definiert"; }
    }

    function toString()
    {
      $output="<br><br># CHANNEL: ".$this->name;
      $output=$output."<br># --------------";
      return $output;
    }
 }

 ////////////////////////////////////////////////////////////
 // STATISCHE FUNKTIONEN fr infoscreenControlData KLASSE

  // Diese Klasse ld ein gespeichertes InfoscreenControlDataObjekt mit allen Daten
  // callingScript == Name des aufrufenden Scripts
  function loadInfoscreenControlDataObject($callingScript)
 {
    if (file_exists("./Data/infoscreenControl_DATA.php"))
    {
      $fileArray = file("./Data/infoscreenControl_DATA.php");
      $dataObject = unserialize($fileArray[1]);

      if ($callingScript == "infoscreenControl.php")
      {
          // prfen, ob in den extren gespeicherten InfoscreenData-Objekten aktuellere Daten vorliegen.
          $update = FALSE;
          foreach ($dataObject->infoscreenGroups as $group)
          {
            foreach ($group->infoscreens as $screen)
            {
              $screenDataFromDisk = loadInfoscreenObject($screen->ID);
              if ($screenDataFromDisk!=NULL)
              {
                if ($screenDataFromDisk->lastContact > $screen->lastContact)
                {
                  // Daten update im Objekt
                  $update = TRUE;
                  $dataObject->infoscreenGroups[$group->name]->nfoscreens[$screen->ID] = $screenDataFromDisk;
                }
              }
            }
          }
          if ($update) {$dataObject->saveThisObject();}
      }

      return $dataObject;
    }
    else
    {
      return new infoscreenControlData();
    }
 }

 function loadInfoscreenObject($name)
 {
    if (file_exists("./Data/infoscreen_".$name."_DATA.php"))
    {
      $fileArray = file("./Data/infoscreen_".$name."_DATA.php");
      return unserialize($fileArray[1]);
    }
    else
    {
      return NULL;
    }
 }

  // Testet, ob eine der Infscreen unter der IP erreicht werden kann
  function connectTestToInfoscreen($ip)
  {    
    $fp = @fsockopen ($ip, 3143, $errno, $errstr, 5);
    if (!$fp) {
      return FALSE;
    } 
    else 
    {
      // Befehl senden
      fputs ($fp, "Hello Infoscreen\n\r");
      
      // Antwort lesen
      $antwort ="";
      while (!feof($fp)) 
      {
        $antwort = $antwort.fgets($fp,128);
      }
      fclose($fp);
      return TRUE;
    }
  }
  
    // Testet, ob eine der Infscreen unter der IP erreicht werden kann
  function sendDirectCommandToScreen($ip,$command)
  {    
    $fp = fsockopen ($ip, 3143, $errno, $errstr, 5);
    if (!$fp) {
      return "";
    } 
    else 
    {
      // Befehl senden
      fputs ($fp, $command."\n\r");
      
      // Antwort lesen
      $antwort ="";
      while (!feof($fp)) 
      {
        $antwort = $antwort.fgets($fp,128);
      }
      fclose($fp);
      return $antwort;
    }
  }

?>